<template>
  <div>
    <div class="card">
      <nav class="navbar has-background-white-bis">
        <div class="navbar-brand">
          <span class="navbar-item title is-2">Listado de Jugadores</span>
        </div>
        <div class="navbar-menu">
          <div class="navbar-end">
            <div class="navbar-item">
              <a class="button regular is-purple is-medium" @click="add">
                <span>Agregar</span>
                <span><i class="fa fa-plus" style=" margin-left: 9px;"></i></span>
              </a>
            </div>
          </div>
        </div>
      </nav>
      <div class="section">
          <b-table :loading="isLoading" :data="data">
               <b-table-column field="image" label="Foto" width="40"  sortable v-slot="props">
                <img
                class="rounded-image-profile"
                    :src="'data:image/jpg;base64, ' + props.row.image"
                    alt="Image"
                  />
            </b-table-column>
                <b-table-column field="name" label="Nombre" width="40"  sortable v-slot="props">
                {{ props.row.name }}
            </b-table-column>
              <b-table-column field="lastName" label="Apellido" width="40"  sortable  v-slot="props">
                {{ props.row.lastName }}
            </b-table-column>
             <b-table-column field="genderType" label="Sexo" width="40"  sortable  v-slot="props">
                {{ props.row.genderType == 0 ? 'Masculino' : 'Femenino' }}
            </b-table-column>
              <b-table-column field="age" label="Edad" width="40"  sortable  v-slot="props">
                {{ props.row.age }}
            </b-table-column>
            
             <b-table-column field="ranking" label="Ranking" width="40"  sortable  v-slot="props">
                {{ props.row.ranking }}
            </b-table-column>
              <b-table-column  label="Acciones" width="40"   v-slot="props">
               <div class="buttons is-centered" style="
    margin-left: -74px;
">
              <b-tooltip
                type="is-warning"
                label="Editar"
              >
                <b-button
                  outlined
                  @click="edit(props.row.id)"
                  type="advise"
                  ><b-icon icon="pencil"></b-icon
                ></b-button>
              </b-tooltip>
              <b-tooltip
                type="is-danger"
                label="Eliminar"
              >
                <b-button
                  outlined
                  @click="remove(props.row.id)"
                  type="alert"
                  ><b-icon icon="delete"></b-icon
                ></b-button>
              </b-tooltip>
            </div>
            </b-table-column>
                <template #empty>
                <div class="has-text-centered title is-4">😢 No hay registro</div>
            </template>
          </b-table>
      </div>
    </div>
  </div>
</template>
<script lang='ts'>
import Player from "@/models/player/player.model";
import PlayerService from "@/services/player.service";
import { Component, Vue, Watch } from "vue-property-decorator";

@Component
export default class PlayerTableComponent extends Vue {

  data:Array<Player> = [];
  isLoading:boolean = false;
  playerService:PlayerService = new PlayerService();
  created() {
        this.getPlayers();
  }


    public add() {
        this.$router.push(`${this.$router.currentRoute.path}/agregar`)
    }

    public edit(id: number) {
        this.$router.push(`${this.$router.currentRoute.path}/editar/${id}`)
    }

    public remove(id: number) {
        this.$buefy.dialog.confirm({
            title: 'Confirmación',
            message: '¿Desea eliminar este registro?',
            confirmText: 'Adelante!',
            cancelText: 'Cancelar',
            type: 'is-danger',
            size: 'is-medium',
            hasIcon: true,
            onConfirm: () => this.confirmRemove(id)
        })
    }

     protected async confirmRemove(id: number) {
           this.playerService.deletePlayer(id).then(resp =>{
               this.getPlayers();
           })

    }

  getPlayers(){
      this.isLoading = true;
     this.playerService.getPlayer().then(resp =>{
         this.data = resp.data;
     }).finally(()=>{
         this.isLoading = false;
     })
  }

 
 
}
</script>


